- job:
    name: jdk14-specjbb2015-benchmark
    project-type: matrix
    defaults: global
    description: |
        * Runs the specjbb2015 benchmark in composite mode (i.e., single VM, single node).
    properties:
        - authorization:
            everyone-flat:
                - job-read
            openjdk-members:
                - job-build
                - job-cancel
        - build-discarder:
            days-to-keep: 30
            num-to-keep: 10
            artifact-num-to-keep: 5
    disabled: true
    node: j12-qrep-01
    display-name: 'DELETE ME'
    axes:
        - axis:
            type: user-defined
            name: BUILD_TYPE
            values:
                - release
        - axis:
            type: slave
            name: label
            values:
                - j12-qrep-01
    execution-strategy:
        sequential: true
    wrappers:
        - workspace-cleanup:
            dirmatch: false
        - timestamps
        - matrix-tie-parent:
            node: j12-qrep-01
    builders:
        - shell: |
            #!/bin/bash

            set -exu

            ## Extract jdk
            tar xf ~/workspace/jdk14-build-image/BUILD_TYPE/${BUILD_TYPE}/label/${NODE_NAME}/out/jdk14-${BUILD_TYPE}.tar.gz
            export JAVA_HOME=${WORKSPACE}/jdk14-${BUILD_TYPE}
            export PATH=$JAVA_HOME/bin:$PATH
            which java
            java -version

            ## Extract specjbb2015 product
            CACHE_FILES=$HOME/srv/jdk-cache
            tar xf $CACHE_FILES/SPECjbb2015-jdk11.tar.gz

            ## Run test

            SPECJBB_PRODUCT_HOME=SPECjbb2015-1.00

            # This commented-out invocation is a quick test that
            # takes about 10 minutes to complete - which can be
            # useful when debugging.

            #(cd $SPECJBB_PRODUCT_HOME; \
            # time java \
            #   -Dspecjbb.controller.rtcurve.duration.min=500 \
            #   -Dspecjbb.controller.rtcurve.duration.max=1500 \
            #   -Dspecjbb.controller.type=PRESET \
            #   -Dspecjbb.controller.preset.ir=4000 \
            #   -Dspecjbb.controller.preset.duration=100 \
            #   -jar specjbb2015.jar -m composite)

            (cd $SPECJBB_PRODUCT_HOME; java -XX:+UseLargePages -XX:-UseBiasedLocking -Xmx12g -Xms12g -XX:+UseParallelOldGC -jar specjbb2015.jar -ikv -m composite)

            mkdir -p out

            datafile=$(basename $(echo $SPECJBB_PRODUCT_HOME/specjbb*.data.gz) | sed "s/\(specjbb2015\)/\1-${BUILD_TYPE}/")

            cp $SPECJBB_PRODUCT_HOME/specjbb*.data.gz out/$datafile

            java -jar $SPECJBB_PRODUCT_HOME/specjbb2015.jar \
              -m REPORTER \
              -raw $SPECJBB_PRODUCT_HOME/config/template-M.raw \
              -p $SPECJBB_PRODUCT_HOME/config/specjbb2015.props \
              -s $SPECJBB_PRODUCT_HOME/specjbb2015-C-*.data.gz \
              -l 1

            tar -acf out/specjbb-result-${BUILD_TYPE}.tar.gz result

            rm -rf html
            mkdir html
            cp -a result/**/report-00001/* html
            cp html/*0001.html html/index.html
    publishers:
        - archive:
            artifacts: 'out/*.gz'
        - html-publisher:
            name: 'HTML Report'
            dir: 'html'
            files: 'index.html'
            keep-all: true
